/* $Id: compressor.cpp 28 2004-12-08 09:53:19Z olau $ */

#include <stdlib.h>
#include <string.h>

#define RLE_marker		-1

char *RLE_compress(char *s)
{
	int i = 0;
	int p = 0;
	char *rle = (char *) malloc(strlen(s) + 1);
	for (;;)
	{
		int n = 0;
		char oldch = s[i];
		if (oldch == '\0')
			break;
		i++;
      /* FIXME: Was passiert, wenn RLE_Marker im
         Text vorkommt? */
		while ((s[i] == oldch) && (n < 256) && (s[i] != '\0'))
		{
			i++;
			n++;
		}
		rle[p] = oldch;
      p++;
		if (n > 1)
		{
			rle[p] = (char) RLE_marker;
         p++;
			rle[p] = (char) n;
         p++;
		}
		else if (n == 1)
		{
			rle[p] = oldch;
         p++;
		}
	}
	rle[p] = '\0';

	rle = (char *) realloc(rle, p + 1);
	return rle;
}



char *RLE_decompress(char *c)
{
   // sicherheitshalber den zehnfachen Platz 
   // des komprimierten Strings belegen
   /* FIXME: bei stark komprimierten Texten fhrt dieses
      Vorgehen zwangslufig zu Zugriffsverletzungen */
   int requestedsize = 10 * strlen(c) * sizeof(char);
	char *s = (char *) malloc(requestedsize);
	int p = 0;
	int i = 0;
   int n;
	for (;;)
	{
		char ch = c[i];
		if (ch == '\0')
			break;
		if (c[i + 1] == RLE_marker)
		{
			n = c[i + 2];
			for (int j = 0; j <= n; j++)
				s[p++] = ch;
			i += 3;
		}
		else
		{
			s[p] = ch;
         p++;
			i++;
		}
	}
	s[p] = '\0';
	s = (char *) realloc(s, p + 1);
	return s;
}
